routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/**
 * All Admin Group Route 
*/
Route::group(['as' => 'admin.', 'prefix' => 'admin', 'namespace' => 'Admin'],  function() {
    // Admin Login and Logout
    Route::get('/login', 'Auth\LoginController@showLoginForm')->name('login'); 
    Route::post('/login', 'Auth\LoginController@login')->name('login.submit');
    Route::post('/logout', 'Auth\LoginController@adminLogout')->name('logout');
    // End 
    // Admin Dashboard
    Route::get('/', 'AdminController@index')->name('dashboard');
    // End 
    // Admin Profile
    Route::match(['get', 'patch'], '/profile','AdminController@profile')->name('profile');
    // End
    //Admin Setting 
    Route::get('setting/','SettingController@general')->name('setting');
    Route::get('setting/general/','SettingController@general')->name('setting.general');
    Route::get('setting/under-construction','SettingController@underConstruction')->name('setting.underconstruction');
    Route::post('setting/save/general','SettingController@save')->name('setting.general.save');
    Route::post('setting/save/underconstruction','SettingController@save')->name('setting.underconstruction.save');
    Route::get('setting/miscellaneous','SettingController@miscellaneous')->name('setting.miscellaneous');
    Route::post('setting/save/miscellaneous','SettingController@save')->name('setting.miscellaneous.save');
    //End

    // Media 
    Route::get('media/','MediaController@index')->name('media');
    Route::get('media/create','MediaController@create')->name('media.create');
    Route::post('media/store','MediaController@store')->name('media.store');
    Route::post('media/ckeditor','MediaController@ckditor_store')->name('media.ckeditor');
    Route::get('media/ckbrowse','MediaController@ckbrowse')->name('media.ckbrowse');
    Route::get('media/delete/{id}','MediaController@destroy')->name('media.delete');
    Route::post('media/delete-all','MediaController@deleteall')->name('media.delete.all');
    // end

    // Pages 
    Route::get('pages/','PageController@index')->name('pages');
    Route::get('page/create','PageController@create')->name('pages.create');
    Route::post('page/save','PageController@store')->name('pages.save');
    Route::get('page/edit/{id}','PageController@edit')->name('pages.edit');
    Route::post('page/update/{id}','PageController@update')->name('pages.update');
    Route::get('page/delete/{id}','PageController@destroy')->name('pages.delete');
    // End
    /**
     * Posts
     */
    Route::get('posts/','PostController@index')->name('posts');
    Route::get('post/create','PostController@create')->name('posts.create');
    Route::post('post/save','PostController@store')->name('posts.save');
    Route::get('post/edit/{id}','PostController@edit')->name('posts.edit');
    Route::post('post/update/{id}','PostController@update')->name('posts.update');
    Route::get('post/delete/{id}','PostController@destroy')->name('posts.delete');
    /**
     * End 
     */
    /**
     * Category
     */
    Route::get('categories/','CategoryController@index')->name('categories');
    Route::post('category/save','CategoryController@store')->name('categories.save');
    Route::get('category/edit/{id}','CategoryController@edit')->name('categories.edit');
    Route::post('category/update/{id}','CategoryController@update')->name('categories.update');
    Route::get('category/delete/{id}','CategoryController@destroy')->name('categories.delete');
    /**
     * End 
     */
    /**
     * Tags
     */
    Route::get('tags/','TagController@index')->name('tags');
    Route::post('tag/save','TagController@store')->name('tags.save');
    Route::get('tag/delete/{id}','TagController@destroy')->name('tags.delete');
    Route::get('tag/status/{id}','TagController@status')->name('tags.status');
    Route::post('tag/ajax','TagController@ajax')->name('tags.ajax');
    /**
     * End 
     */
    /**
     * Menus
     */
    Route::get('menus/','MenuController@index')->name('menus');
    Route::post('menu/save','MenuController@store')->name('menus.save');
    Route::get('menu/status/{id}','MenuController@status')->name('menus.status');
    Route::get('menu/edit/{id}','MenuController@edit')->name('menus.edit');
    Route::post('menu/update/{id}','MenuController@update')->name('menus.update');
    Route::get('menu/add-items/{id}','MenuController@addItem')->name('menus.additems');
    Route::post('menu/getdetails','MenuController@getMenuDetails')->name('menus.getdetail');
    Route::post('menu/items/save','MenuController@saveMenuItems')->name('menus.items.save');
    Route::get('menu/delete/{id}','MenuController@destroy')->name('menus.delete');
    /**
     * End 
     */

    /**
     * Admin User
     */
    Route::get('admin-users','AdminUsers@index')->name('adminusers');
    Route::get('admin-user/create','AdminUsers@create')->name('adminuser.create');
    Route::post('admin-user/save','AdminUsers@store')->name('adminuser.store');
    Route::get('admin-user/edit/{id}','AdminUsers@edit')->name('adminuser.edit');
    Route::post('admin-user/update/{id}','AdminUsers@update')->name('adminuser.update');
    Route::post('admin-user/special-permission/{id}','AdminUsers@specialPermission')->name('adminuser.special.permission');
    /**
     * End
     */
    /**
     * User
     */
    Route::get('users','UserController@index')->name('users');
    Route::get('user/create','UserController@create')->name('users.create');
    Route::post('user/store','UserController@store')->name('users.save');
    Route::get('user/edit/{id}','UserController@edit')->name('users.edit');
    Route::post('user/update/{id}','UserController@update')->name('users.update');
    /**
     * End
     */
    /**
     * Role
     */
    Route::get('roles','RoleController@index')->name('roles');
    Route::post('role/save','RoleController@store')->name('role.save');
    Route::get('role/edit/{id}','RoleController@edit')->name('role.edit');
    Route::post('role/update/{id}','RoleController@update')->name('role.update');
    Route::get('role/delete/{id}','RoleController@destroy')->name('role.delete');
    Route::post('role-add-to-permissions/{id}','RoleController@addRoleToPermissions')->name('roleToPermissions');
    /**
     * End 
     */
    /**
     * Permissions
     */
    Route::get('permissions','PermissionController@index')->name('permissions');
    Route::post('permission/save','PermissionController@store')->name('permission.save');
    Route::get('permission/edit/{id}','PermissionController@edit')->name('permission.edit');
    Route::post('permission/update/{id}','PermissionController@update')->name('permission.update');
    Route::get('permission/delete/{id}','PermissionController@destroy')->name('permission.delete');
    Route::post('permission-add-to-roles/{id}','PermissionController@addPermissionToRoles')->name('permissionToroles');
});
/**
 * End of Admin route
 */

// Route::get('/', function () {
//    dd();
// });
Route::get('/', 'PageController@index')->name('home-page');
// Route::get('/test', function () {
    
//     $a = Auth::guard('admin')->user();
//     $r = Userdata::get($a,'test');
//     dd($r);
// });
// Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/Admin/AdminUsers.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests\AdminProfile;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use App\Admin;
use App\Role;
use App\Permission;
class AdminUsers extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:admin');
        $this->middleware('permission:list.adminuser',['only'=>['index']]);
        $this->middleware('permission:create.adminuser',['only'=>['create']]);
        $this->middleware('permission:store.adminuser',['only'=>'store']);
        $this->middleware('permission:edit.adminuser',['only'=>'edit']);
        $this->middleware('permission:update.adminuser',['only'=>'update']);
        $this->middleware('permission:delete.adminuser',['only'=>'destroy']);
        $this->middleware('permission:adminuser.special.permission.save',['only'=>['specialPermission']]);

    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = Admin::where('id','!=',Auth::guard('admin')->user()->id)->get();
        return view('admin.adminuser.index',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $roles = Role::where('guard_name','admin')->pluck('name','id')->toArray();
        return view('admin.adminuser.create',compact('roles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(AdminProfile $request)
    {
        $user = Admin::create([
        	'name' => $request->name,
        	'email' => $request->email,
        	'password' => Hash::make($request->new_password)
        ]);
        if($user)
        {
            $user->roles()->sync($request->roles);
            return redirect()->route('admin.adminusers')
                    ->with('success', 'Admin User Created Successfully');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        $user = Admin::find($id);
        $admin = Auth::guard('admin')->user();
        $roles = Role::where('guard_name','admin')->pluck('name','id')->toArray();
        if($user && $id != Auth::guard('admin')->user()->id){
            $userRoles = $user->roles()->get();
            $per = [];
            foreach($userRoles as $role)
            {
                $per = array_merge($per,$role->permissions()->pluck('name','id')->toArray());
            }
            $allPermissions = Permission::where('guard_name','admin')->pluck('name','id')->toArray();
            $resOfPermissions = array_diff($allPermissions,$per);
            
            return view('admin.adminuser.edit',compact('user','roles','resOfPermissions'));
        }
        elseif($id ==Auth::guard('admin')->user()->id)
        {
            return redirect()->route('admin.profile');

        }
        else
        {
            return redirect()->route('admin.adminusers')
                        ->with('error',$id .' id dose not exist!');
        }

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(AdminProfile $request, $id)
    {
        $user = Admin::find($id);
        $inputs['name']=$request->name;
        $inputs['email']=$request->email;
        if($request->new_password !='')
        {
            $inputs['password'] = Hash::make($request->new_password);
        }

        $result = $user->update($inputs);
        $user->roles()->sync($request->roles);
            if($result){
                return redirect()->route('admin.adminuser.edit',$id)
                        ->with('success','Admin User updated successfully.');
            }
            else
            {
                return redirect()->route('admin.adminuser.edit',$id)
                        ->with('error','Somethings is wrong!');
            }
    }

    /**
     * To Give Special Permission To the Admin User
     */
    public function specialPermission(Request $request, $id)
    {
        $user = Admin::find($id);
        $result = $user->permissions()->sync($request->permissions);
        if($result){
            return redirect()->route('admin.adminuser.edit',$id)
                    ->with('success','Assing special permission.');
        }
        else
        {
            return redirect()->route('admin.adminuser.edit',$id)
                    ->with('error','Somethings is wrong!');
        }
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/adminuser/create.blade.php
@extends('layouts.master')
@section('title') Create Admin Users @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Create Admin Users') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ route('admin.dashboard') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <a href="{{ route('admin.adminusers') }}">
                    <span>{{ __('Admin Users') }}</span>
                </a>

            </li>
            <li>
                <span>{{ __('Create') }}</span>
            </li>

        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>

</header>
<section class="panel">
    <header class="panel-heading">
        <div class="panel-actions">
            <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>

        </div>

        <h2 class="panel-title">{{ __('Create Admin User') }}</h2>
    </header>
    <div class="panel-body">
        {{  Form::open(array('route' => 'admin.adminuser.store','method' => 'POST','files'=> true))}}
        <div class="form-group @error('name') has-error @enderror">
            {{ Form::label('name', 'Name') }}

            {{ Form::text('name',null,array('id'=>'name','placeholder'=>'','class'=>'form-control')) }}
            @error('name')
                <label id="name" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('email') has-error @enderror">
            {{ Form::label('email', 'Email') }}

            {{ Form::text('email',null,array('id'=>'email','placeholder'=>'','class'=>'form-control')) }}
            @error('email')
                <label id="name" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class=" form-group @error('roles') has-error @enderror">
            {{ Form::label('roles', 'Roles', array('class' => 'control-label')) }}
            {!! Form::select('roles[]',$roles,null,array('multiple'=>'multiple','class'=>'form-control','id'=>'roles'))!!}
            @error('roles')
                <label id="roles-error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('new_password') has-error @enderror">
            {{ Form::label('new_password', 'New Password', array('class' => 'control-label')) }}
            {{ Form::password('new_password',array('id'=>'password','placeholder'=>'','class'=>'form-control')) }}
            @error('new_password')
                <label id="new_password_error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('conf_password') has-error @enderror">
            {{ Form::label('conf-password', 'Conf Password', array('class' => 'control-label')) }}
            {{ Form::password('conf_password',array('id'=>'conf-password','placeholder'=>'','class'=>'form-control')) }}
            @error('conf_password')
                <label id="conf_password_error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group">
            <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Save') }}">
        </div>
        {{ Form::close() }}
    </div>
</section>
@endsection
{{-- Page Specific CSS Vendor --}}
@push('cssvender')
<link rel="stylesheet" href="{{ asset('admin-design/assets/vendor/select2/css/select2.css') }}" />
@endpush
{{-- Page Specific JS Vendor --}}
@push('jsvender')
    <script src="{{ asset('admin-design/assets/vendor/select2/js/select2.js') }}"></script>
@endpush
@push('adminjs')
<script>
    $("#roles").select2();
</script>
@endpush

resources/views/admin/adminuser/edit.blade.php
@extends('layouts.master')
@section('title') Edit Admin Users @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Edit Admin Users') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ route('admin.dashboard') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <a href="{{ route('admin.adminusers') }}">
                    <span>{{ __('Admin Users') }}</span>
                </a>

            </li>
            <li>
                <span>{{ __('Edit') }}</span>
            </li>

        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>

</header>
<section class="panel">
    <header class="panel-heading">
        <div class="panel-actions">
            <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>

        </div>

        <h2 class="panel-title">{{ __('Edit Admin User') }}</h2>
    </header>
    <div class="panel-body">
        {!! Form::model($user, ['method' => 'POST','route' => ['admin.adminuser.update', $user->id]]) !!}
        <div class="form-group @error('name') has-error @enderror">
            {{ Form::label('name', 'Name') }}

            {{ Form::text('name',null,array('id'=>'name','placeholder'=>'','class'=>'form-control')) }}
            @error('name')
                <label id="name" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('email') has-error @enderror">
            {{ Form::label('email', 'Email') }}

            {{ Form::text('email',null,array('id'=>'email','placeholder'=>'','class'=>'form-control')) }}
            @error('email')
                <label id="name" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class=" form-group @error('roles') has-error @enderror">
            {{ Form::label('roles', 'Roles', array('class' => 'control-label')) }}
            {!! Form::select('roles[]',$roles,null,array('multiple'=>'multiple','class'=>'form-control','id'=>'roles'))!!}
            @error('roles')
                <label id="roles-error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('new_password') has-error @enderror">
            {{ Form::label('new_password', 'New Password', array('class' => 'control-label')) }}
            {{ Form::password('new_password',array('id'=>'password','placeholder'=>'','class'=>'form-control')) }}
            @error('new_password')
                <label id="new_password_error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group @error('conf_password') has-error @enderror">
            {{ Form::label('conf-password', 'Conf Password', array('class' => 'control-label')) }}
            {{ Form::password('conf_password',array('id'=>'conf-password','placeholder'=>'','class'=>'form-control')) }}
            @error('conf_password')
                <label id="conf_password_error" class="error" >{{ $message }}</label>
            @enderror
        </div>
        <div class="form-group">
            <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Save') }}">
        </div>
        {{ Form::close() }}
    </div>
</section>
@permit('admin','adminuser.special.permission')

<section class="panel">
    <header class="panel-heading">
        <div class="panel-actions">
            <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>

        </div>

        <h2 class="panel-title">{{ __('Special Permission to Admin User') }}</h2>
    </header>
    <div class="panel-body">
        @if ($resOfPermissions)
        {{  Form::open(array('route' => array('admin.adminuser.special.permission',$user->id),'method' => 'POST','files'=> true))}}
        
        @foreach ($resOfPermissions as $key => $item)
        @php($userperm = $user->permissions()->find($key))
       
            
                @if ($userperm)
                    @php($val = true)
                @else 
                    @php($val = null)
                @endif
                <div class="form-group col-sm-8">
                    <div class="checkbox-custom checkbox-default">
                    
                   
                    {{ Form::checkbox('permissions[]', $key,$val,array('id'=>'permission-'.$key)) }}
                    {{ Form::label('permission-'.$key, $item)}}
                    </div>
                </div>
                <div class="col-sm-4">
                   @php($perm=App\Permission::find($key))
                   {{ $perm->description }}
                </div> 
                @endforeach
                <div class="form-group col-sm-12">
                  
                    <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Add Permissions') }}">
                </div>
                {{ Form::close() }}
        @else
            <h4>{{ __('User already have all permissions')  }}</h4>
        @endif
        
    </div>
</section>
@endpermit
@endsection
{{-- Page Specific CSS Vendor --}}
@push('cssvender')
<link rel="stylesheet" href="{{ asset('admin-design/assets/vendor/select2/css/select2.css') }}" />
@endpush
{{-- Page Specific JS Vendor --}}
@push('jsvender')
    <script src="{{ asset('admin-design/assets/vendor/select2/js/select2.js') }}"></script>
@endpush

@push('adminjs')
    @if ($message = Session::get('success'))
        <script>
            new PNotify({
                    title: 'Admin User',
                    text: '{{ $message }}',
                    type: 'success'
                });
        </script>
    @endif
    @if ($message = Session::get('error'))
        <script>
            new PNotify({
                    title: 'Admin User',
                    text: '{{ $message }}',
                    type: 'error'
                });
        </script>
    @endif
    <script>
        $("#roles").select2();
    </script>
@endpush

resources/views/admin/adminuser/index.blade.php
@extends('layouts.master')
@section('title') Admin Users @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Admin Users') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ route('admin.dashboard') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <span>{{ __('Admin Users') }}</span>
            </li>
            
        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>
</header>
<section class="panel">
    <header class="panel-heading">
        <div class="panel-actions">
            <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
            
        </div>

        <h2 class="panel-title">{{ __('Admin User') }}</h2>
    </header>
    <div class="panel-body">
        <table class="table table-bordered table-striped mb-none" id="datatable-default">
            <thead>
                <tr>
                    <th>{{ 'Sl' }}</th>
                    <th>{{ 'Name' }}</th>
                    <th>{{ 'Email' }}</th>
                    
                    
                    <th>{{ 'Action' }}</th>
                </tr>
            </thead>
            <tbody>
                @php ($i = 1)  
                @foreach ($users as $key =>$user)
                <tr>
                    <td>{{ $i++ }}</td>
                    <td>{{ $user->name }}</td>
                    <td>{{ $user->email }}</td>
                    
                    <td>
                        <a href="{{ route('admin.adminuser.edit',$user->id) }}"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a>
                        
                        <a href="{{ route('admin.categories.delete',$user->id) }}" onclick="return confirm('Are you sure you want delete ?');"><i class="fa fa-trash-o" aria-hidden="true"></i></a>  

                       
                        
                    </td>
                </tr>   
                @endforeach
                
                
            </tbody>
        </table>
    </div>
</section>
@endsection
@push('cssvender')
    <link rel="stylesheet" href="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/css/datatables.css')}}" />
@endpush

@push('jsvender')
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables/media/js/jquery.dataTables.js')}}"></script>
	<script src="{{ asset('admin-design/assets/vendor/jquery-datatables/extras/TableTools/js/dataTables.tableTools.min.js')}}"></script>
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/js/datatables.js')}}"></script>
@endpush
@push('adminjs')
<script src="{{ asset('admin-design/assets/javascripts/tables/examples.datatables.default.js')}}"></script>
    @if ($message = Session::get('success'))
        <script>
            new PNotify({
                    title: 'Admin User',
                    text: '{{ $message }}',
                    type: 'success'
                });
        </script>
    @endif
    @if ($message = Session::get('error'))
        <script>
            new PNotify({
                    title: 'Admin User',
                    text: '{{ $message }}',
                    type: 'error'
                });
        </script>
    @endif
@endpush